﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr172_1
{
    // Объявление делегата: 
    delegate void MyDelegate(int n);

    // Класс: 
    class MyClass {
        // Закрытое целочисленное поле: 
        private int number;
        // Конструктор с одним аргументом: 
        public MyClass(int n) {
            // Присваивание значения полю: 
            set(n);
        }
        // Метод для присваивания значения полю: 
        public void set(int n) {
            // Присваивание значения полю: 
            number = n;
        }
        // Переопределение метода ToString(): 
        public override string ToString() { 
            return "Поле number=" + number;
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Создание объекта:
            MyClass A = new MyClass(100);
            // Объектная переменная ссылается 
            // на ранее созданный объект:
            MyClass B = A;
            // Переменной типа делегата значением присваивается 
            // ссылка на метод объекта:
            MyDelegate apply = A.set;
            // Переменной присваивается ссылка на новый объект:
            A = new MyClass(200);
            // Проверка значений полей объектов:
            Console.WriteLine(A);
            Console.WriteLine(B);
            // Вызов экземпляра делегата: 
            apply(300);
            Console.WriteLine();
            // Проверка значений полей объектов:
            Console.WriteLine(A);
            Console.WriteLine(B);
            // Задержка:
            Console.ReadLine();
        }
    }
}
